/*****************************************************
 *  18$B%S%C%H%G%k%?%7%0%^(BA/D$B$r;H$C$?%G!<%?%m%,!<(B
 *    I2C$B$G(BADC$B$H(BLCD$B$H(BEEPROM$B$r@\B3(B
 *$B!!(B  SPI$B$G(BRTCC$B@\B3(B $B!!(B EUSART$B$G(BPC$B$K@\B3(B
 * $B!!%U%!%$%kL>!'(BDataLogger.c
******************************************************/
#include  <htc.h>
#include   "lcd_lib4.h"
#include  "i2c_lib4.h"
/***** $B%3%s%U%#%.%e%l!<%7%g%s@_Dj(B *********/

// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = ON    // Clock Out Enable (CLKOUT function is enabled on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config PLLEN = ON       // PLL Enable (4x PLL enabled)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)
/** $B%0%m!<%P%kDj?tJQ?tDj5A(B **/
unsigned int    HWidth, VWidth, DSwitch, State;
unsigned char   DFlag, YFlag, TFlag, RFlag, WFlag, SetFlag;
unsigned char   Gain, Result[5], Rdata;
unsigned int    WRAddress, RDAddress;
struct rtcc {
    unsigned char Year;
    unsigned char Mon;
    unsigned char Day;
    unsigned char Hour;
    unsigned char Min;
    unsigned char Sec;
};
struct rtcc RTCC;
/* $BI=<(MQ%G!<%?(B */
unsigned char StMsg[] = "\r\n\r\nStart Application!\r\nCommand=";
unsigned char YMsg[] = "\r\n  YYMMDD = ";
unsigned char TMsg[] = "\r\n  HHMMSS = ";
unsigned char Vmsg1[]   = "+x.xxxx,+x.xxxx,";
unsigned char Vmsg2[]   = "+x.xxxx,+x.xxxx,";
unsigned char MsgBuf[]  = "xx:xx:xx,";
/** $B4X?t%W%m%H%?%$%T%s%0(B **/
unsigned int ADConv(unsigned char ch);
void GetTime(void);
void SetTime(void);
void TimeDisplay(void);
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer);
unsigned char SPIRead(unsigned char add);
void SPIWrite(unsigned char adrs, unsigned char data);
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer);
void Mesure(void);
void Display(unsigned char ch);
void ftostring(int seisu, int shousu, float data, unsigned char *buffer);
void EEWrite(unsigned int EEAdrs, unsigned char Data);
unsigned char EERead(unsigned int EEAdrs);
void Send(unsigned char Data);
unsigned char Receive(void);
void TimeSave(void);

/******** $B%a%$%s4X?t(B  ************/
void main(void) {
    int i;

    /** $B%/%m%C%/@_Dj(B **/
    OSCCON = 0x70;                      // $BFbB"(B8MHz$B!_(BPLL=32MHz
    /** $BF~=PNO%]!<%H$N@_Dj(B ***/
    APFCON0 = 0x84;                     // RX=RC5, TX=RC4
    APFCON1 = 0x00;                     // SDO2=RC1
    ANSELA = 0x00;                      // $B$9$Y$F%G%8%?%k(B
    ANSELB = 0x00;                      // $B%G%8%?%k(B
    TRISA = 0x2B;                       // RA0,1,3,5$B$N$_F~NO@_Dj(B
    TRISB = 0x70;                       // RB4,5,6$B$N$_F~NO(B
    TRISC = 0x25;                       // RC0,2,5$B$N$_F~NO(B
    WPUC = 0x05;                        // RC0, 2 $B%W%k%"%C%W(B
    OPTION_REGbits.nWPUEN = 0;          // $B%W%k%"%C%WM-8z2=(B
    /* $B%?%$%^(B1$B$N@_Dj!!(B0.5sec$B<~4|(B */
    T1CON = 0x85;                       // Ext$B!"(B1/1$B!!(BOn Async
    TMR1H = 0xC0;                       // 0.5sec
    TMR1L = 0x00;
    T1GCON =0x00;                       // $B%2!<%H5!G=$J$7(B
    /** I2C$B=i4|2=(B **/
    SSP1ADD = 0x09;                     // 100kHz@32MHz
    SSP1CON1 = 0x38;                    // I2C$B%$%M!<%V%k(B
    SSP1STAT = 0;                       // $B>uBV%/%j%"(B
    /* MSSP SPI$B!!=i4|@_Dj(B 2Mbps*/
    SSP2STAT = 0x00;                    // SMP=0 middle, CKE=0,
    SSP2CON1 = 0x31;                    // Enable, CKP=1, 32MHz/16
    SSP2CON2 = 0x00;
    SSP2CON3 = 0x00;
    LATC7 = 1;                          // CS High
    /* RTC$B=i4|CM%;%C%H(B */
    RTCC.Sec = 0;                       // RTC$B=i4|%;%C%H(B
    RTCC.Min = 0;
    RTCC.Hour = 0;
    RTCC.Day = 0;
    RTCC.Mon = 0;
    RTCC.Year = 0;
    SetFlag = 0;                        // $B;~9o@_DjBT$A%U%i%0%/%j%"(B
    /* USART$B$N=i4|@_Dj(B */
    TXSTA = 0x20;					// TXSTA,$BAw?.%b!<%I@_Dj(B
    RCSTA = 0x90;					// RCSTA,$B<u?.%b!<%I@_Dj(B
    BAUDCON=0x08;                       // BAUDCON$B!!(B16bit
    SPBRG = 103;                        // SPBRG,$BDL?.B.EY@_Dj(B(19.2kbps)
    PIR1bits.RCIF = 0;                  // $B3d$j9~$_%U%i%0%/%j%"(B
    /* $BJQ?t=i4|2=(B */
    DFlag = 1;                          // $BI=<(MW5a%U%i%0%;%C%H(B
    WFlag = 0;                          // EEPROM$B=q$-9~$_%U%i%0%j%;%C%H(B
    /* EERPOM$B%"%I%l%9=i4|2=(B */
    WRAddress = 0;
    RDAddress = 0;
    /* LCD$B=i4|2=(B */
    lcd_init();                         // LCD$B=i4|2=(B
    lcd_str("Start App!");              // $B3+;O%a%C%;!<%8I=<((B
    lcd_cmd(0xC0);
    lcd_str("*Wait Time Set!*");
    i = 0;                              // $BMWAG%$%s%G%C%/%9=i4|2=(B
    while(StMsg[i] != 0)                // $B3+;O%a%C%;!<%8=*$o$jH=Dj(B
        Send(StMsg[i++]);               // 1$BJ8;zAw?.(B    
    /* $B3d$j9~$_5v2D(B */
    TMR1IE = 1;                         // $B%?%$%^(B1$B5v2D(B
    PIE1bits.RCIE = 1;                  // USART$B<u?.3d$j9~$_5v2D(B
    PEIE = 1;                           // $B<~JU5v2D(B
    GIE = 1;                            // $B%0%m!<%P%k5v2D(B
    
    /************ $B%a%$%s%k!<%W(B  ************************/
    while (1) {
        /* $B7WB,<B9T(B */
        if(DFlag){                                  // $B7WB,I=<(%U%i%0%*%s$+!)(B
            DFlag = 0;                              // $B7WB,I=<(%U%i%0%*%U(B
            if(SetFlag != 0)                        // $B;~9o@_DjBT$A%U%i%0%A%'%C%/(B
                Mesure();                           // $B7WB,<B9T!"I=<((B
            else
                TimeDisplay();                      // $B;~9oI=<((B
        }
        /* EEPROM$B$X=q$-9~$_(B */
        if(WFlag){                                  // $B=q$-9~$_%U%i%0%*%s$+!)(B
            lcd_icon(2, 1);                         // $BL\0u%"%$%3%s%*%s(B
            TimeSave();                             // $B;~9o%P%C%U%!%;%C%H(B
            i = 0;                                  // $BMWAG%$%s%G%C%/%9=i4|2=(B
            while(MsgBuf[i] != 0)                   // $B;~9o=*$o$jH=Dj(B
                EEWrite(WRAddress++, MsgBuf[i++]);  // $B%G!<%?(B1$B%P%$%H=q$-9~$_(B
            i = 0;                                  // $BMWAG%$%s%G%C%/%9=i4|2=(B
            while(Vmsg1[i] != 0)                    // CH0,1$B=*$o$jH=Dj(B
                EEWrite(WRAddress++, Vmsg1[i++]);   // 1$B%P%$%H=q$-9~$_(B
            i = 0;                                  // $BMWAG%$%s%G%C%/%9=i4|2=(B
            while(Vmsg2[i] != 0)                    // Ch2,3$B=*$o$jH=Dj(B
                EEWrite(WRAddress++, Vmsg2[i++]);   // 1$B%P%$%H=q$-9~$_(B
            EEWrite(WRAddress++, 0x0D);             // $BI|5"=q$-9~$_(B
            EEWrite(WRAddress++, 0x0A);             // $B2~9T=q$-9~$_(B
            EEWrite(WRAddress, 0x00);               // End Mark$B=q$-9~$_(B
            lcd_icon(2, 0);                         // $BL\0u%"%$%3%s%*%U(B
            WFlag = 0;                              // $B=q$-9~$_%U%i%0%*%U(B
        }
        /* EEPROM$B$+$iFI$_=P$7(BUSART$BAw?.(B */
        if(RFlag){                                  // $BFI$_=P$7%U%i%0%*%s$+!)(B
            lcd_icon(3, 1);                         // $BL\0u%"%$%3%s(B
            Send('>');                              // $BL\0u2~9T(B
            Send('\r');
            Send('\n');
            RDAddress = 0;                          // $B%"%I%l%9:G=i(B
            do{
                Rdata = EERead(RDAddress++);        // $BFI$_=P$7(B
                Send(Rdata);                        // $BAw?.(B
            }while((Rdata != 0) && (RFlag));        // $B=*$o$jH=Dj(B
            Send('\r');                             // $B=*C<2~9T(B
            Send('\n');
            lcd_icon(3, 0);                         // $BL\0u%"%$%3%s%*%U(B
            RFlag = 0;                              // $BFI$_=P$7%U%i%0%*%U(B
        }

        /* $BG/7nF|@_DjCM(BUSART$B<u?.(B */
        if(YFlag){
            T1CONbits.TMR1ON = 0;                   // $B%?%$%^(B1$B0lC6Dd;_(B
            YFlag = 0;                              // $BG/7n@_Dj%U%i%0%/%j%"(B
            PIE1bits.RCIE = 0;                      // $B<u?.3d$j9~$_6X;_(B
            i=0;                                    // $B%a%C%;!<%8I=<((B
            while(YMsg[i] != 0)                     // YYMMDD
                Send(YMsg[i++]);                    // $B8+=P$7=PNO(B
            RTCC.Year = (Receive() & 0x0F) << 4;    // $BG/FI$_9~$_(B
            RTCC.Year += Receive() & 0x0F;
            RTCC.Mon = (Receive() & 0x0F) << 4;     // $B7nFI$_9~$_(B
            RTCC.Mon += Receive() & 0x0F;
            RTCC.Day = (Receive() & 0x0F) << 4;     // $BF|FI$_9~$_(B
            RTCC.Day += Receive() & 0x0F;
            SetTime();                              // RTC$B=q$-9~$_(B
            Send('\r');                             // $B2~9T=PNO(B
            Send('\n');
            PIE1bits.RCIE = 1;                      // $B<u?.3d$j9~$_:F5v2D(B
            T1CONbits.TMR1ON = 1;                   // $B%?%$%^(B1$B:F%9%?!<%H(B
        }
        /* $B;~J,IC@_DjCM(BUSART$B<u?.(B */
        if(TFlag){
            T1CONbits.TMR1ON = 0;                   // $B%?%$%^(B1$B0lC6Dd;_(B
            TFlag = 0;                              // $B;~9o%U%i%0%/%j%"(B
            PIE1bits.RCIE = 0;                      // $B<u?.3d$j9~$_6X;_(B
            i = 0;                                  // $B%a%C%;!<%8I=<((B
            while(TMsg[i] != 0)                     // HHMMSS
                Send(TMsg[i++]);                    // $B8+=P$7=PNO(B
            RTCC.Hour = (Receive() & 0x0F) << 4;    // $B;~FI$_9~$_(B
            RTCC.Hour += Receive() & 0x0F;
            RTCC.Min = (Receive() & 0x0F) << 4;     // $BJ,FI$_9~$_(B
            RTCC.Min += Receive() & 0x0F;
            RTCC.Sec = (Receive() & 0x0F) << 4;     // $BICFI$_9~$_(B
            RTCC.Sec += Receive() & 0x0F;
            SetTime();                              // RTC$B@_Dj(B
            Send('\r');                             // $B2~9T=PNO(B
            Send('\n');
            SetFlag = 1;                            // $B;~9o%;%C%H=*N;7WB,3+;O(B
            PIE1bits.RCIE = 1;                      // $B<u?.3d$j9~$_:F5v2D(B
            T1CONbits.TMR1ON = 1;                   // $B%?%$%^(B1$B:F%9%?!<%H(B
        }
     }
}

/************************************************************************/
/*************************************
* $B3d$j9~$_=hM}4X?t(B
* $B!!%?%$%^#1(B 0.5$BIC(B
* $B!!<u?.3d$j9~$_(B
*************************************/
void interrupt isr(void){
    unsigned char cmnd;

    if(PIR1bits.TMR1IF){                    // $B%?%$%^#13d$j9~$_$+!)(B
        PIR1bits.TMR1IF = 0;                // $B3d$j9~$_%U%i%0%/%j%"(B
        TMR1H = 0xC0;                       // 0.5sec$B:F@_Dj(B
        DFlag = 1;                          // $B7WB,I=<(%U%i%0%*%s(B
        LATCbits.LATC6 ^= 1;                // $BL\0u(BLED$BE@LG(B
        /* $B3JG<;~4V%A%'%C%/(B */
        GetTime();                          // $B;~9o<hF@(B
        if(((RTCC.Sec & 0x0F)  == 0) && (SetFlag))  // 10sec$B!)(B
            WFlag = 1;                      // EEPROM$B=q$-9~$_%U%i%0%*%s(B
    }
    if(PIR1bits.RCIF){                      // $B<u?.3d$j9~$_$+!)(B
        PIR1bits.RCIF = 0;                  // $B<u?.3d$j9~$_%U%i%0%/%j%"(B
        LATC3 ^= 1;                         // $BL\0u(BLED$BE@LG(B
        cmnd = RCREG;                       // $B<u?.%G!<%?<hF@(B
        Send(cmnd);
        switch(cmnd){
            case 'r':                       // r$B$N>l9g(B
                RFlag = 1;                  // $BFI$_=P$73+;O(B
                break;
            case 'e':                       // e$B$N>l9g(B
                RFlag = 0;                  // $BFI$_=P$7Cf;_(B
                Send('\r');
                Send('\n');
                break;
            case 'y':                       // y$B$N>l9g(B
                YFlag = 1;                  // $BG/7nF|@_Dj%U%i%0%;%C%H(B
                break;
            case 't':                       // t$B$N>l9g(B
                TFlag = 1;                  // $B;~J,IC@_Dj%U%i%0%;%C%H(B
                break;
            default:
                Send('?');                  // $B%(%i!<=PNO(B
                Send('\r');
                Send('\n');
                break;
        }
    }
}

/***************************************
 *$B!!%G%k%?%7%0%^JQ49%G!<%?<hF@I=<((B
 ***************************************/
void Mesure(void){
    /** $B7WB,<B9T(B **/
    switch(State){                          // $B%9%F!<%H$G?J$a$k(B
        case 0:                             // $B=i4|>uBV$N>l9g(B
            SendI2C(0xD0, 0x8C);            // ADC$B=i4|2=(B Gain=1 18$B%S%C%H(B CH0
            State = 1;                      // $B%9%F!<%H<!$X(B
            break;
        case 1:                             // $B%3%^%s%IAw?.8e$N>l9g(B
            GetDataI2C(0xD0, Result, 3);    // $B%G!<%?<hF@(B 3$B%P%$%H(B into Result
            Display(0);                     // CH0$BI=<((B
            SendI2C(0xD0, 0xAC);            // CH1 18bit Gain x1 $BJQ493+;O(B
            State = 2;                      // $B%9%F!<%H<!$X(B
            break;
        case 2:                             // $BF~NO40N;BT$A$N>l9g(B
            GetDataI2C(0xD0, Result, 3);    // $B%G!<%?<hF@(B 3$B%P%$%H(B into Result
            Display(1);                     // CH1$BB,DjCMJQ49I=<((B
            SendI2C(0xD0, 0xCC);            // CH2$B%9%?!<%H(B
            State = 3;                      // $B%9%F!<%H$rLa$9(B
            break;
        case 3:                             // $BF~NO40N;BT$A$N>l9g(B
            GetDataI2C(0xD0, Result, 3);    // $B%G!<%?<hF@(B 3$B%P%$%H(B into Result
            Display(2);                     // CH2$BB,DjCMJQ49I=<((B
            SendI2C(0xD0, 0xEC);            // CH3$B%9%?!<%H(B
            lcd_icon(2, 0);                 // $B7WB,CfL\0u%*%U(B
            State = 4;                      // $B%9%F!<%H$rLa$9(B
            break;
        case 4:                             // $BF~NO40N;BT$A$N>l9g(B
            GetDataI2C(0xD0, Result, 3);    // $B%G!<%?<hF@(B 3$B%P%$%H(B into Result
            Display(3);                     // CH3$BB,DjCMJQ49I=<((B
            SendI2C(0xD0, 0x8C);            // CH0$BJQ493+;O(B
             State = 1;                     // $B%9%F!<%H$rLa$9(B
            break;
        default: break;
    }
}

/***************************************
*  $BB,DjCM$r49;;$7I=<((B
***************************************/
void Display(unsigned char ch){
    long Value;
    float fValue;

    /* $BJQ49F~NOCM$r?tCM$KJQ49!!(B*/
    if((Result[0] & 0x02) == 0){                // $B@5$NCM$N>l9g(B
        Value = ((long)(Result[0]&0x01)<<16)+
            ((long)Result[1]<<8)+((long)Result[2]);
        /* $B%A%c%M%k$4$H$KId9f%;%C%H(B */
        switch(ch){
            case 0: Vmsg1[0] = '+'; break;
            case 1: Vmsg1[8] = '+'; break;
            case 2: Vmsg2[0] = '+'; break;
            case 3: Vmsg2[8] = '+'; break;
            default: break;
        }
    }
    else{                                       // $BIi$NCM$N>l9g(B
        Result[0] = ~Result[0] & 0x01;          // 0,1$BH?E>(B
        Result[1] = ~Result[1];                 // 0,1$BH?E>(B
        Result[2] = ~Result[2];
        Value = ((long)Result[0]<<16)+
        ((long)Result[1]<<8)+((long)Result[2])+1;
        /* $B%A%c%M%k$4$H$KId9f%;%C%H(B*/
        switch(ch){
            case 0: Vmsg1[0] = '-'; break;
            case 1: Vmsg1[8] = '-'; break;
            case 2: Vmsg2[0] = '-'; break;
            case 3: Vmsg2[8] = '-'; break;
            default: break;
        }
    }
    /* $BB,DjCM$X$NJQ49$HI=<(!!(B*/
    fValue = (2.0480*Value)/0x1FFFF;            // V,A$B$KJQ49(B
    /* $B%A%c%M%k$4$H$KJ8;z$KJQ49$7%P%C%U%!$KJ]B8(B */
    switch(ch){
        case 0:
            ftostring(1,4, fValue, Vmsg1+1);    // $BJ8;z$KJQ49(B
            break;
        case 1:
            ftostring(1,4, fValue, Vmsg1+9);    // $BJ8;z$KJQ49(B
            break;
        case 2:
            ftostring(1,4, fValue, Vmsg2+1);    // $BJ8;z$KJQ49(B
            break;
        case 3:
            ftostring(1,4, fValue, Vmsg2+9);    // $BJ8;z$KJQ49(B
            break;
        default:
            break;
    }
    /* LCD$BI=<(<B9T(B */
    lcd_cmd(0x80);                              // 1$B9TL\;XDj(B
    lcd_str(Vmsg1);                             // CH0, 1$BI=<((B
    lcd_cmd(0xC0);                              // 2$B9TL\;XDj(B
    lcd_str(Vmsg2);                             // CH2, 3$BI=<((B
 }

/********************************************
 *  $B;~9o$NI=<(%5%V4X?t(B
 *$B!!!!7nF|!!;~J,IC(B
 ********************************************/
void TimeDisplay(void){
    lcd_cmd(0x80);                              // 1$B9TL\A*Br(B
    lcd_data(' ');
    lcd_data(((RTCC.Mon >> 4) & 0x01) + 0x30);  // $B7nI=<((B
    lcd_data((RTCC.Mon & 0x0F) + 0x30);
    lcd_data('/');                              // /$BI=<((B
    lcd_data(((RTCC.Day >> 4) & 0x03) + 0x30);  // $BF|I=<((B
    lcd_data((RTCC.Day & 0x0F) + 0x30);
    lcd_data(' ');                              // $B%9%Z!<%9(B
    lcd_data(' ');
    lcd_data(((RTCC.Hour >> 4) & 0x03) + 0x30); // $B;~I=<((B
    lcd_data((RTCC.Hour & 0x0F) + 0x30);
    lcd_data(':');                              // :$BI=<((B
    lcd_data(((RTCC.Min >> 4) & 0x0F) + 0x30);  // $BJ,I=<((B
    lcd_data((RTCC.Min & 0x0F) + 0x30);
    lcd_data(':');                              // :$BI=<((B
    lcd_data(((RTCC.Sec >> 4) & 0x0F) + 0x30);  // $BICI=<((B
    lcd_data((RTCC.Sec & 0x0F) + 0x30);
}
/*************************************
 *  $B;~9o%P%C%U%!J]B84X?t(B
 *************************************/
void TimeSave(void){
    /** $B;~9o$rJ8;z$KJQ49$7%P%C%U%!$KJ]B8(B **/
    MsgBuf[7] = (RTCC.Sec & 0x0F) + 0x30;
    MsgBuf[6] = ((RTCC.Sec >> 4) & 0x0F) + 0x30;    // $BIC(B
    MsgBuf[4] = (RTCC.Min & 0x0F) + 0x30;
    MsgBuf[3] = ((RTCC.Min >> 4) & 0x0F) + 0x30;    // $BJ,(B
    MsgBuf[1]  = (RTCC.Hour & 0x0F) + 0x30;
    MsgBuf[0]  = ((RTCC.Hour >> 4) & 0x0F) + 0x30;  // $B;~(B
}

/***************************************
 * RTC$B$X$N;~9o@_Dj(B
 **************************************/
void SetTime(void){
    SPIWrite(0x80, RTCC.Sec);
    SPIWrite(0x81, RTCC.Min);
    SPIWrite(0x82, RTCC.Hour+0x40);     // 24H mode
    SPIWrite(0x84, RTCC.Day);
    SPIWrite(0x85, RTCC.Mon);
    SPIWrite(0x86, RTCC.Year);
}
/**************************************
 * RTC$B$+$i$N;~9o<hF@(B
 **************************************/
void GetTime(void){
    RTCC.Sec  = SPIRead(0x00);
    RTCC.Min  = SPIRead(0x01);
    RTCC.Hour = SPIRead(0x02) & 0x3F;   // 24H$B6hJL:o=|(B
    RTCC.Day  = SPIRead(0x04);
    RTCC.Mon  = SPIRead(0x05) & 0x1F;   // $B@$5*:o=|(B
    RTCC.Year = SPIRead(0x06);
}
/*************************************
 *  SPI$B$G(B1$B%P%$%HFI$_=P$7(B
 *************************************/
unsigned char SPIRead(unsigned char add){
    unsigned char dumy;

    LATCbits.LATC7 = 0;                          // CS Low
    dumy = SSP2BUF;                     // $B%@%_!<FI$_=P$7(B
    SSP2BUF = add;                      // $B%"%I%l%9Aw?.(B
    while(!SSP2STATbits.BF)             // $BAw<u?.40N;BT$A(B
    dumy = SSP2BUF;                     // $B%@%_!<FI$_=P$7(B
    SSP2BUF = 0;                        // $B%@%_!<%G!<%?Aw?.(B
    while(!SSP2STATbits.BF);            // $BAw<u?.40N;BT$A(B
    LATCbits.LATC7 = 1;                          // CS High
    return(SSP2BUF);                    // $B<u?.%G!<%?$rJV$9(B
}
/*************************************
 * SPI$B$G(B1$B%P%$%H=q$-9~$_(B
 *************************************/
void SPIWrite(unsigned char adrs, unsigned char data){
    unsigned char dumy;
    
    LATCbits.LATC7 = 0;                          // CS Low
    dumy = SSP2BUF;                     //$B%@%_!<FI$_=P$7(B
    SSP2BUF = adrs;                     // $B%"%I%l%9Aw?.(B
    while(!SSP2STATbits.BF);            // $BAw?.40N;BT$A(B
    dumy = SSP2BUF;                     //$B%@%_!<FI$_=P$7(B    
    SSP2BUF = data;                     // $B%G!<%?Aw?.(B
    while(!SSP2STATbits.BF);            // $BAw?.40N;BT$A(B
    dumy = SSP2BUF;                     // $B%@%_!<FI$_=P$7(B
    LATCbits.LATC7 = 1;                          // CS High
}
/***************************************
* int$B@0?t$+$i(BASCII$BJ8;z$KJQ49(B
****************************************/
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer){
    unsigned char i;

    buffer += digit;                            // $B:G8e$N?t;z0LCV(B
    for(i=digit; i>0; i--) {                    // $BJQ49$O2<0L$+$i>e0L$X(B
        buffer--;                               // $B%]%$%s%?!<#1(B
        *buffer = (data % 10) + '0';            // ASCII$B$X(B
        data = data / 10;                       // $B<!$N7e$X(B
    }
}
/***************************************
* long$B@0?t$+$i(BASCII$BJ8;z$KJQ49(B
****************************************/
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer){
	unsigned char i;

	buffer += digit;			// $B:G8e$N?t;z0LCV(B
	for(i=digit; i>0; i--) {		// $BJQ49$O2<0L$+$i>e0L$X(B
		buffer--;			// $B%]%$%s%?!<#1(B
		*buffer = (data % 10) + '0';	// ASCII$B$X(B
		data = data / 10;		// $B<!$N7e$X(B
	}
}
/***********************************
* Float$B$+$iJ8;zNs$XJQ49(B
* $B9g7WM-8z7e$O(B8$B7e0J2<$H$9$k$3$H(B
***********************************/
void ftostring(int seisu, int shousu, float data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                         //$B>.?tIt7e$"$j$+(B
        buffer += seisu+shousu+1;           //$BA4BN7e?t!\>.?tE@(B
    else                                    //$B>.?tIt7e$J$7$N$H$-(B
        buffer += seisu + shousu;           //$BA4BN7e?t$N$_(B
    buffer--;                               //$BG[Ns%]%$%s%?(B-1
    for(i=0; i<shousu; i++)                 //$B>.?tIt$r@0?t$KJQ49(B
        data = data * 10;                   //$B#1#0G\(B
    /* dumy$B$,%*!<%P!<%U%m!<$9$k$HJQ49IT2D(B($B#87e$,8B3&(B) */
    dumy = (long) (data + 0.5);             //$B;M<N8^F~$7$F@0?t$KJQ49(B
    for(i=shousu; i>0; i--)	{           //$B>.?t7e?tJ,7+$jJV$7(B
        *buffer =(dumy % 10)+'0';           //$B?tCM$rJ8;z$KJQ493JG<(B
        buffer--;                           //$B3JG<>l=j2<0L$+$i>e0L$X(B
        dumy /= 10;                         //$B<!$N7e$X(B
    }
    if(shousu != 0) {                       //$B>.?t7e(B0$B$J$i>.?tE@$J$7(B
        *buffer = '.';                      //$B>.?tE@$r3JG<(B
        buffer--;                           //$B%]%$%s%?(B-1
    }
    for(i=seisu; i>0; i--) {                //$B@0?t7eJ,7+$jJV$7(B
        *buffer = (dumy % 10)+'0';          //$B?tCM$rJ8;z$KJQ493JG<(B
        buffer--;                           //$B%]%$%s%?(B-1
        dumy /= 10;                         //$B<!$N7e$X(B
    }
    i = 0;                                  // $B%V%i%s%-%s%0=hM}(B
    buffer++;
    while((i<seisu-1)&&(*buffer == '0')){   // $B>e0L7e$,(B0$B$N4V(B
        *buffer = ' ';                      // $B%V%i%s%/$KJQ49(B
        buffer++;
        i++;
    }
}
/****************************************************************************/
/*************************************
* EEPROM 1$B%P%$%H=q$-9~$_4X?t(B
**************************************/
void EEWrite(unsigned int EEAdrs, unsigned char Data){
    unsigned int i;

    IdleI2C();                              // $B%"%$%I%kBT$A(B
    SSP1CON2bits.SEN = 1;                   // $B%9%?!<%H=PNO(B//
    while(SSP1CON2bits.SEN);                // $B%9%?!<%H=*N;BT$A(B
    SendByte(0xA0);                         // EEPROM write mode
    SendByte((EEAdrs >> 8) & 0xFF);         // $B=q$-9~$_%"%I%l%9>e0LAw?.(B
    SendByte(EEAdrs & 0xFF);                // $B=q$-9~$_%"%I%l%92<0LAw?.(B
    SendByte(Data);                         // $B=q$-9~$_%G!<%?Aw?.(B
    SSP1CON2bits.PEN = 1;                   // $B%9%H%C%W=PNO(B
    while(SSP1CON2bits.PEN);                // $B%9%H%C%W=*N;BT$A(B
    for(i=0; i<10000; i++);                 // $B=q$-9~$_40N;BT$A$NCY1d(B
}
/*************************************
* EEPROM 1$B%P%$%HFI$_=P$74X?t(B
**************************************/
unsigned char EERead(unsigned int EEAdrs){
    unsigned char result;

    IdleI2C();                              // $B%"%$%I%kBT$A(B
    SSP1CON2bits.SEN = 1;                   // $B%9%?!<%H=PNO(B//
    while(SSP1CON2bits.SEN);                // $B%9%?!<%H=*N;BT$A(B
    SendByte(0xA0);                         // EEPROM$B%A%C%W%"%I%l%9Aw?.(B write mode
    SendByte((EEAdrs >> 8) & 0xFF);         // $B=q$-9~$_%"%I%l%9>e0LAw?.(B
    SendByte(EEAdrs & 0xFF);                // $B=q$-9~$_%"%I%l%92<0LAw?.(B
    /** $BFI$_=P$7(B **/
    SSP1CON2bits.ACKDT = 1;                 // Nack(1)$B@_Dj(B
    SSP1CON2bits.SEN = 1;                   // $B%9%?!<%H=PNO(B//
    while(SSP1CON2bits.SEN);                // $B%9%?!<%H=*N;BT$A(B
        SendByte(0xA1);                     // EEPROM$B%A%C%W%"%I%l%9Aw?.(B Read mode
    SSP1CON2bits.RCEN = 1;                  // $B<u?.5v2D(B RCEN$B%;%C%H(B
    while(!SSP1STATbits.BF);                // $B<u?.BT$A(B BF$B%A%'%C%/(B
    SSP1CON2bits.ACKEN = 1;                 // NACK$BJVAw(B
    IdleI2C();                              // $B%"%$%I%kBT$A(B
    result = SSP1BUF;                       // $B<u?.%G!<%?<hF@(B
    SSP1CON1bits.SSPOV = 0;                 // $B%(%i!<%/%j%"(B
    SSP1CON2bits.PEN = 1;                   // $B%9%H%C%W=PNO(B
    while(SSP1CON2bits.PEN);                // $B%9%H%C%W=*N;BT$A(B
    return(result);                         // $BFI$_=P$7%G!<%?$rJV$9(B
}
/********************************
 * USART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!TXSTAbits.TRMT);                     // $BAw?.%l%G%#!<BT$A(B
    TXREG = Data;                               // $BAw?.<B9T(B
}
/*** $B<u?.%5%V4X?t(B($B%(%i!<=hM}>JN,(B) ***/
unsigned char Receive(void){
    while(!PIR1bits.RCIF);                      // $B%G!<%?<u?.BT$A(B
    PIR1bits.RCIF = 0;                          // $B%U%i%0%/%j%"(B
    if((RCSTAbits.OERR) || (RCSTAbits.FERR)){   // $B%(%i!<%A%'%C%/(B
       RCSTA = 0;                               // USART$BL58z2=(B
       RCSTA = 0x90;                            // USART$B:FM-8z2=(B
       while(!PIR1bits.RCIF);                   // $B%G!<%?<u?.BT$A(B
       PIR1bits.RCIF = 0;                       // $B%U%i%0%/%j%"(B
    }
    Send(RCREG);                                // $B%(%3!<Aw?.=PNO(B
    return(RCREG);				// $B<u?.%G!<%?<hF@$7La$jCM$H$9$k(B
}
