/***********************************************
*  $B1U>=I=<(4o%i%$%V%i%j(B
*  I2C$B%$%s%?!<%U%'!<%9(B
*    lcd_init()    ----- $B=i4|2=(B
*    lcd_cmd(cmd)  ----- $B%3%^%s%I=PNO(B
*    lcd_data(data) ----- $B#1J8;zI=<(=PNO(B
*    lcd_str(ptr)  ----- $BJ8;zNsI=<(=PNO(B
*    lcd_clear()   ----- $BA4>C5n(B
**********************************************/
#include <xc.h>
#include "lcd_lib4.h"
#include "i2c_lib4.h"

/*********************************
* $B1U>=$X(B1$BJ8;zI=<(%G!<%?=PNO(B
*********************************/
void lcd_data(unsigned char data)
{
    CmdI2C(0x7C, 0x40, data);
    __delay_us(30);				// $BCY1d(B
}

/*******************************
* $B1U>=$X#1%3%^%s%I=PNO(B
*******************************/
void lcd_cmd(unsigned char cmd)
{
    CmdI2C(0x7C, 0x00, cmd);
    /* Clear$B$+(BHome$B$+(B */
    if((cmd == 0x01)||(cmd == 0x02))
        __delay_ms(2);			// 2msec$BBT$A(B
    else
        __delay_us(30);			// 30$B&L(Bsec$BBT$A(B
}
/*******************************
*  $B=i4|2=4X?t(B
*******************************/
void lcd_init(void)
{
    delay_100ms(1);
    lcd_cmd(0x38);			// 8bit 2line Normal mode
    lcd_cmd(0x39);			// 8bit 2line Extend mode
    lcd_cmd(0x14);			// OSC 183Hz BIAS 1/5
    /* $B%3%s%H%i%9%H@_Dj(B */
    lcd_cmd(0x70 + (CONTRAST & 0x0F));
    lcd_cmd(0x5C + (CONTRAST >> 4));
    lcd_cmd(0x6A);			// Follower for 5.0V
//    lcd_cmd(0x6B);			// Ffollwer for 3.3V
    delay_100ms(3);
    lcd_cmd(0x38);			// Set Normal mode
    lcd_cmd(0x0C);			// Display On
    lcd_cmd(0x01);			// Clear Display
}
/******************************
* $BA4>C5n4X?t(B
******************************/
void lcd_clear(void)
{
    lcd_cmd(0x01);			//$B=i4|2=%3%^%s%I=PNO(B
}
/*****************************
* $BJ8;zNsI=<(4X?t(B
*****************************/
void lcd_str(const unsigned char* ptr)
{
    while(*ptr != 0)			//$BJ8;z<h$j=P$7(B
        lcd_data(*ptr++);		//$BJ8;zI=<((B
}
/*****************************
*  $B%"%$%3%sI=<(@)8f4X?t(B
*****************************/
void lcd_icon(unsigned char num, unsigned char onoff)
{
    lcd_cmd(0x39);			// Extend mode
    lcd_cmd(0x40 | ICON[num][0]);	// $B%"%$%3%s%"%I%l%9;XDj(B
    if(onoff)
        lcd_data(ICON[num][1]);         // $B%"%$%3%s%*%s%G!<%?(B
    else
        lcd_data(0x00);			// $B%"%$%3%s%*%U%G!<%?(B
    lcd_cmd(0x38);			// Normal Mode
}

/******************************
*  100msec$BCY1d4X?t(B
******************************/
void delay_100ms(unsigned int time)
{
    time *= 4;			// 4$BG\(B
    while(time){
        __delay_ms(25);		// 25msec
        time--;			// 100msec x time
    }
}
